// Lifetime Stat Tracker. Put it in some sub-directoy under config, Spades if ya like
// then add the line Include("whereyouputit\\stattrak.cs"); in config\autoexec.cs.
// This script absolutely requires the Presto Pack, so get it now.
// http://www.planetstarsiege.com/presto/

// Thanks to Writer and Presto for their help with a few functions, especially export()

// Feel free to make changes, but if you do, i'd appreciate it if you'd post info about what
// you changed to the Planet Starsiege scripting forum.
// http://forums.planetstarsiege.com/index.asp?topic=205

// Whenever you kill, die, or capture a flag, a small HUD will pop up in the upper left
// showing your liftime stats.

// DO NOT REMOVE STATS.CS FROM THE CONFIG DIRECTORY. This is where your stats are held.
// If you delete that file, you lose your stats.
//

//
// Added by [Phx] Phoenix 15/04/1999
//
// INSTALLATION
//
//	See above or just replace the version you have at the moment.....  :)
//
// BINDINGS
//
//	None, the function works automatically according to events within the game.
//
// KNOWN PROBLEMS
//
//	- None at this time.
//
// FUTURE DEVELOPMENTS
//
//	- Talk to SPADES about them I think.
//
// VERSION HISTORY
//
//	15/04/1999		v1.1 release	Altered the StatTrak::PopUp function to use StatusHUD instead.
//
// That's about it for the mo'.
//
//	Phoenix 15/04/99
//


Include("presto\\event.cs");
Include("presto\\KillTrak.cs");
Include("presto\\teamtrak.cs");

function StatTrak::Update()
{
  File::delete("config\\stats.cs");

  // Rewrite stats file and records
  export("$StatTrak::NextRec", "config\\stats.cs");
  export("$StatTrak::Name*", "config\\stats.cs", True);
  export("$StatTrak::Kills*", "config\\stats.cs", True);
  export("$StatTrak::Deaths*", "config\\stats.cs", True);
  export("$StatTrak::Flagcaps*", "config\\stats.cs", True);
  echo("File written");
  StatTrak::PopUp();
}

function StatTrak::Kill()
{
  $StatTrak::Kills[$StatTrak::ClientNum]++;
  echo("Kill");
  StatTrak::Update();
}

function StatTrak::Death()
{
  $StatTrak::Deaths[$StatTrak::ClientNum]++;
  echo("Death");
  StatTrak::Update();
}

function StatTrak::Flagcaps(%teamNum, %client)
{
  echo("Someone captured the flag");
  echo(%client);
  if(%client == getManagerId())
  {
    echo("Flag captured");
    $StatTrak::Flagcaps[$StatTrak::ClientNum]++;
    StatTrak::Update();
  }
}

function StatTrak::ReadFile()
{
  echo("Attempting to read file");
  %clientname = client::getname(getManagerId());
  $StatTrak::ClientNum = "";
  $StatTrak::NextRec = "";
  //Check for existence of previous stats
  exec("stats.cs");

  //Check for existence of previous records for this client name
  for(%i=0; %i<$StatTrak::NextRec; %i++)
  {
      if($StatTrak::Name[%i] == %clientname)
        $StatTrak::ClientNum = %i;
  }

  //If the name isn't found, create a new record
  if($StatTrak::ClientNum == "")
  {

    echo("Creating new record");
    //This is the first record. Initialize NextRec
    if($StatTrak::NextRec == "")
    {
      $StatTrak::NextRec = 0;
      echo("Creating first record");
    }

    $StatTrak::ClientNum = $StatTrak::NextRec;
    $StatTrak::NextRec++;
    $StatTrak::Name[$StatTrak::ClientNum] = %clientname;
    $StatTrak::Kills[$StatTrak::ClientNum] = 0;
    $StatTrak::Deaths[$StatTrak::ClientNum] = 0;
    $StatTrak::Flagcaps[$StatTrak::ClientNum] = 0;
  }
}

function StatTrak::KD(%killer, %victim, %weapon)
{
  if(%victim == getManagerId())
    StatTrak::Death();
  else if(%killer == getManagerId())
    StatTrak::Kill();
}

function StatTrak::PopUp()
{
	StatusHUD(StatTrak);

//  HUD::AddText(statPopUp, "K:" @ $StatTrak::Kills[$StatTrak::ClientNum] @ " D:" @ $StatTrak::Deaths[$StatTrak::ClientNum] @ " C:" @ $StatTrak::Flagcaps[$StatTrak::ClientNum]);
//  HUD::Display(statPopUp, true);
//  schedule("HUD::Display(statPopUp, false);", 5);
}

Event::Attach(eventConnected, StatTrak::ReadFile);
Event::Attach(eventKillTrak, StatTrak::KD);
Event::Attach(eventFlagCaptured, StatTrak::Flagcaps);

//HUD::New(statPopUp, StatTrak::PopUp, 700, 190, 100, 15);